searchData={"items":[{"type":"module","title":"NLdoc.Spec","doc":"This module defines the Ecto schema for the NLdoc spec objects.","ref":"NLdoc.Spec.html"},{"type":"type","title":"NLdoc.Spec.blockquote_child/0","doc":"","ref":"NLdoc.Spec.html#t:blockquote_child/0"},{"type":"function","title":"NLdoc.Spec.blockquote_children/0","doc":"","ref":"NLdoc.Spec.html#blockquote_children/0"},{"type":"type","title":"NLdoc.Spec.descriptor/0","doc":"","ref":"NLdoc.Spec.html#t:descriptor/0"},{"type":"function","title":"NLdoc.Spec.descriptors/0","doc":"","ref":"NLdoc.Spec.html#descriptors/0"},{"type":"type","title":"NLdoc.Spec.document_child/0","doc":"","ref":"NLdoc.Spec.html#t:document_child/0"},{"type":"function","title":"NLdoc.Spec.document_children/0","doc":"","ref":"NLdoc.Spec.html#document_children/0"},{"type":"function","title":"NLdoc.Spec.find_recursive/2","doc":"Recursively find the first spec object to match the given predicate, or return the given default value.\n\nThis function performs a depth-first search through the children of a spec object or list of spec objects,\nand returns the first spec object for which the predicate returns true.","ref":"NLdoc.Spec.html#find_recursive/2"},{"type":"function","title":"Examples - NLdoc.Spec.find_recursive/2","doc":"iex> alias NLdoc.Spec.{Paragraph, Text}\n    iex> NLdoc.Spec.find_recursive(\n    ...>   [%Text{text: \"1\"}, %Text{text: \"2\"}],\n    ...>   fn object -> object.text === \"2\" end\n    ...> )\n    %Text{text: \"2\"}\n    iex> NLdoc.Spec.find_recursive(\n    ...>   [%Paragraph{children: [%Text{text: \"1\"}, %Text{text: \"2\"}]}, %Paragraph{children: [%Text{text: \"3\"}, %Text{text: \"4\"}]}],\n    ...>   fn\n    ...>     %Text{text: text} -> text |> String.to_integer() |> rem(2) === 0\n    ...>     _ -> false\n    ...>   end\n    ...> )\n    %Text{text: \"2\"}\n    iex> NLdoc.Spec.find_recursive([], fn _ -> true end)\n    nil\n    iex> NLdoc.Spec.find_recursive([], fn _ -> true end, \"test\")\n    \"test\"\n    iex> NLdoc.Spec.find_recursive([%Text{text: \"1\"}, %Text{text: \"2\"}], fn _ -> false end)\n    nil\n    iex> NLdoc.Spec.find_recursive([%Text{text: \"1\"}, %Text{text: \"2\"}], fn _ -> false end, \"default\")\n    \"default\"","ref":"NLdoc.Spec.html#find_recursive/2-examples"},{"type":"function","title":"NLdoc.Spec.find_recursive/3","doc":"","ref":"NLdoc.Spec.html#find_recursive/3"},{"type":"type","title":"NLdoc.Spec.object/0","doc":"","ref":"NLdoc.Spec.html#t:object/0"},{"type":"function","title":"NLdoc.Spec.objects/0","doc":"","ref":"NLdoc.Spec.html#objects/0"},{"type":"type","title":"NLdoc.Spec.paragraph_child/0","doc":"","ref":"NLdoc.Spec.html#t:paragraph_child/0"},{"type":"function","title":"NLdoc.Spec.paragraph_children/0","doc":"","ref":"NLdoc.Spec.html#paragraph_children/0"},{"type":"type","title":"NLdoc.Spec.text_style/0","doc":"","ref":"NLdoc.Spec.html#t:text_style/0"},{"type":"function","title":"NLdoc.Spec.text_styling/0","doc":"","ref":"NLdoc.Spec.html#text_styling/0"},{"type":"function","title":"NLdoc.Spec.version/0","doc":"Returns the version of the NLdoc API spec that the `NLdoc.Spec` library implements.","ref":"NLdoc.Spec.html#version/0"},{"type":"module","title":"NLdoc.Spec.Asset","doc":"This module defines the Ecto schema for the NLdoc spec Asset object.","ref":"NLdoc.Spec.Asset.html"},{"type":"function","title":"NLdoc.Spec.Asset.changeset/2","doc":"","ref":"NLdoc.Spec.Asset.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.Asset.from_base64/2","doc":"Converts base64 to Asset resource.","ref":"NLdoc.Spec.Asset.html#from_base64/2"},{"type":"function","title":"Examples - NLdoc.Spec.Asset.from_base64/2","doc":"iex> NLdoc.Spec.Asset.from_base64(\"123\", \"data:image/gif;base64,R0lGODlhAQABAAAAACw=\")\n    %NLdoc.Spec.Asset{\n      id: \"123\",\n      encoding: :base64,\n      content_type: \"image/gif\",\n      data: \"R0lGODlhAQABAAAAACw=\"\n    }","ref":"NLdoc.Spec.Asset.html#from_base64/2-examples"},{"type":"function","title":"NLdoc.Spec.Asset.new/1","doc":"This function creates a new `NLdoc.Spec.Asset` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, asset}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Asset.html#new/1"},{"type":"function","title":"NLdoc.Spec.Asset.new!/1","doc":"This function creates a new `NLdoc.Spec.Asset` struct from a map of keys and values, where the keys are snake_case.\nReturns the `asset}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Asset.html#new!/1"},{"type":"function","title":"NLdoc.Spec.Asset.resource_type/0","doc":"","ref":"NLdoc.Spec.Asset.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.Asset.t/0","doc":"","ref":"NLdoc.Spec.Asset.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Asset.to_base64/1","doc":"Converts Asset resource to base64.","ref":"NLdoc.Spec.Asset.html#to_base64/1"},{"type":"function","title":"Examples - NLdoc.Spec.Asset.to_base64/1","doc":"iex> NLdoc.Spec.Asset.to_base64(%NLdoc.Spec.Asset{\n    ...>   id: \"123\",\n    ...>   encoding: :base64,\n    ...>   content_type: \"image/gif\",\n    ...>   data: \"R0lGODlhAQABAAAAACw=\"\n    ...> })\n    \"data:image/gif;base64,R0lGODlhAQABAAAAACw=\"\n\n    iex> NLdoc.Spec.Asset.to_base64(%NLdoc.Spec.Asset{\n    ...>   id: \"123\",\n    ...>   content_type: \"image/gif\",\n    ...>   encoding: nil,\n    ...>   data: <<71, 73, 70, 56, 57, 97, 1, 0, 1, 0, 0, 0, 0, 44>>\n    ...> })\n    \"data:image/gif;base64,R0lGODlhAQABAAAAACw=\"","ref":"NLdoc.Spec.Asset.html#to_base64/1-examples"},{"type":"function","title":"NLdoc.Spec.Asset.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.Asset.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.Asset.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.Asset.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.Asset.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.Asset.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.BlockQuotation","doc":"This module defines the Ecto schema for the NLdoc spec BlockQuotation object.","ref":"NLdoc.Spec.BlockQuotation.html"},{"type":"function","title":"NLdoc.Spec.BlockQuotation.changeset/2","doc":"","ref":"NLdoc.Spec.BlockQuotation.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.BlockQuotation.new/1","doc":"This function creates a new `NLdoc.Spec.BlockQuotation` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, block_quotation}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.BlockQuotation.html#new/1"},{"type":"function","title":"NLdoc.Spec.BlockQuotation.new!/1","doc":"This function creates a new `NLdoc.Spec.BlockQuotation` struct from a map of keys and values, where the keys are snake_case.\nReturns the `block_quotation}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.BlockQuotation.html#new!/1"},{"type":"function","title":"NLdoc.Spec.BlockQuotation.resource_type/0","doc":"","ref":"NLdoc.Spec.BlockQuotation.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.BlockQuotation.t/0","doc":"","ref":"NLdoc.Spec.BlockQuotation.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.BlockQuotation.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.BlockQuotation.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.BlockQuotation.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.BlockQuotation.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.BlockQuotation.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.BlockQuotation.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.BooleanDescriptor","doc":"This module defines the Ecto schema for the NLdoc spec BooleanDescriptor object.","ref":"NLdoc.Spec.BooleanDescriptor.html"},{"type":"function","title":"NLdoc.Spec.BooleanDescriptor.changeset/2","doc":"","ref":"NLdoc.Spec.BooleanDescriptor.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.BooleanDescriptor.new/1","doc":"This function creates a new `NLdoc.Spec.BooleanDescriptor` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, boolean_descriptor}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.BooleanDescriptor.html#new/1"},{"type":"function","title":"NLdoc.Spec.BooleanDescriptor.new!/1","doc":"This function creates a new `NLdoc.Spec.BooleanDescriptor` struct from a map of keys and values, where the keys are snake_case.\nReturns the `boolean_descriptor}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.BooleanDescriptor.html#new!/1"},{"type":"function","title":"NLdoc.Spec.BooleanDescriptor.resource_type/0","doc":"","ref":"NLdoc.Spec.BooleanDescriptor.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.BooleanDescriptor.t/0","doc":"","ref":"NLdoc.Spec.BooleanDescriptor.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.BooleanDescriptor.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.BooleanDescriptor.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.BooleanDescriptor.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.BooleanDescriptor.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.BooleanDescriptor.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.BooleanDescriptor.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.DefinitionDetails","doc":"This module defines the Ecto schema for the NLdoc spec DefinitionDetails object.","ref":"NLdoc.Spec.DefinitionDetails.html"},{"type":"function","title":"NLdoc.Spec.DefinitionDetails.changeset/2","doc":"","ref":"NLdoc.Spec.DefinitionDetails.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.DefinitionDetails.new/1","doc":"This function creates a new `NLdoc.Spec.DefinitionDetails` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, definition_details}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.DefinitionDetails.html#new/1"},{"type":"function","title":"NLdoc.Spec.DefinitionDetails.new!/1","doc":"This function creates a new `NLdoc.Spec.DefinitionDetails` struct from a map of keys and values, where the keys are snake_case.\nReturns the `definition_details}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.DefinitionDetails.html#new!/1"},{"type":"function","title":"NLdoc.Spec.DefinitionDetails.resource_type/0","doc":"","ref":"NLdoc.Spec.DefinitionDetails.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.DefinitionDetails.t/0","doc":"","ref":"NLdoc.Spec.DefinitionDetails.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.DefinitionDetails.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.DefinitionDetails.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.DefinitionDetails.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.DefinitionDetails.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.DefinitionDetails.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.DefinitionDetails.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.DefinitionList","doc":"This module defines the Ecto schema for the NLdoc spec DefinitionList object.","ref":"NLdoc.Spec.DefinitionList.html"},{"type":"function","title":"NLdoc.Spec.DefinitionList.changeset/2","doc":"","ref":"NLdoc.Spec.DefinitionList.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.DefinitionList.new/1","doc":"This function creates a new `NLdoc.Spec.DefinitionList` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, definition_list}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.DefinitionList.html#new/1"},{"type":"function","title":"NLdoc.Spec.DefinitionList.new!/1","doc":"This function creates a new `NLdoc.Spec.DefinitionList` struct from a map of keys and values, where the keys are snake_case.\nReturns the `definition_list}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.DefinitionList.html#new!/1"},{"type":"function","title":"NLdoc.Spec.DefinitionList.resource_type/0","doc":"","ref":"NLdoc.Spec.DefinitionList.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.DefinitionList.t/0","doc":"","ref":"NLdoc.Spec.DefinitionList.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.DefinitionList.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.DefinitionList.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.DefinitionList.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.DefinitionList.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.DefinitionList.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.DefinitionList.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.DefinitionTerm","doc":"This module defines the Ecto schema for the NLdoc spec DefinitionTerm object.","ref":"NLdoc.Spec.DefinitionTerm.html"},{"type":"function","title":"NLdoc.Spec.DefinitionTerm.changeset/2","doc":"","ref":"NLdoc.Spec.DefinitionTerm.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.DefinitionTerm.new/1","doc":"This function creates a new `NLdoc.Spec.DefinitionTerm` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, definition_term}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.DefinitionTerm.html#new/1"},{"type":"function","title":"NLdoc.Spec.DefinitionTerm.new!/1","doc":"This function creates a new `NLdoc.Spec.DefinitionTerm` struct from a map of keys and values, where the keys are snake_case.\nReturns the `definition_term}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.DefinitionTerm.html#new!/1"},{"type":"function","title":"NLdoc.Spec.DefinitionTerm.resource_type/0","doc":"","ref":"NLdoc.Spec.DefinitionTerm.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.DefinitionTerm.t/0","doc":"","ref":"NLdoc.Spec.DefinitionTerm.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.DefinitionTerm.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.DefinitionTerm.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.DefinitionTerm.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.DefinitionTerm.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.DefinitionTerm.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.DefinitionTerm.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.Document","doc":"This module defines the Ecto schema for the NLdoc spec Document object.","ref":"NLdoc.Spec.Document.html"},{"type":"function","title":"NLdoc.Spec.Document.changeset/2","doc":"","ref":"NLdoc.Spec.Document.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.Document.new/1","doc":"This function creates a new `NLdoc.Spec.Document` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, document}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Document.html#new/1"},{"type":"function","title":"NLdoc.Spec.Document.new!/1","doc":"This function creates a new `NLdoc.Spec.Document` struct from a map of keys and values, where the keys are snake_case.\nReturns the `document}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Document.html#new!/1"},{"type":"function","title":"NLdoc.Spec.Document.resource_type/0","doc":"","ref":"NLdoc.Spec.Document.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.Document.t/0","doc":"","ref":"NLdoc.Spec.Document.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Document.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.Document.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.Document.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.Document.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.Document.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.Document.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.Footnote","doc":"This module defines the Ecto schema for the NLdoc spec Footnote object.","ref":"NLdoc.Spec.Footnote.html"},{"type":"function","title":"NLdoc.Spec.Footnote.changeset/2","doc":"","ref":"NLdoc.Spec.Footnote.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.Footnote.new/1","doc":"This function creates a new `NLdoc.Spec.Footnote` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, footnote}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Footnote.html#new/1"},{"type":"function","title":"NLdoc.Spec.Footnote.new!/1","doc":"This function creates a new `NLdoc.Spec.Footnote` struct from a map of keys and values, where the keys are snake_case.\nReturns the `footnote}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Footnote.html#new!/1"},{"type":"function","title":"NLdoc.Spec.Footnote.resource_type/0","doc":"","ref":"NLdoc.Spec.Footnote.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.Footnote.t/0","doc":"","ref":"NLdoc.Spec.Footnote.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Footnote.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.Footnote.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.Footnote.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.Footnote.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.Footnote.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.Footnote.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.FootnoteReference","doc":"This module defines the Ecto schema for the NLdoc spec FootnoteReference object.","ref":"NLdoc.Spec.FootnoteReference.html"},{"type":"function","title":"NLdoc.Spec.FootnoteReference.changeset/2","doc":"","ref":"NLdoc.Spec.FootnoteReference.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.FootnoteReference.new/1","doc":"This function creates a new `NLdoc.Spec.FootnoteReference` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, footnote_reference}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.FootnoteReference.html#new/1"},{"type":"function","title":"NLdoc.Spec.FootnoteReference.new!/1","doc":"This function creates a new `NLdoc.Spec.FootnoteReference` struct from a map of keys and values, where the keys are snake_case.\nReturns the `footnote_reference}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.FootnoteReference.html#new!/1"},{"type":"function","title":"NLdoc.Spec.FootnoteReference.resource_type/0","doc":"","ref":"NLdoc.Spec.FootnoteReference.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.FootnoteReference.t/0","doc":"","ref":"NLdoc.Spec.FootnoteReference.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.FootnoteReference.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.FootnoteReference.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.FootnoteReference.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.FootnoteReference.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.FootnoteReference.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.FootnoteReference.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.Heading","doc":"This module defines the Ecto schema for the NLdoc spec Heading object.","ref":"NLdoc.Spec.Heading.html"},{"type":"function","title":"NLdoc.Spec.Heading.changeset/2","doc":"","ref":"NLdoc.Spec.Heading.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.Heading.new/1","doc":"This function creates a new `NLdoc.Spec.Heading` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, heading}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Heading.html#new/1"},{"type":"function","title":"NLdoc.Spec.Heading.new!/1","doc":"This function creates a new `NLdoc.Spec.Heading` struct from a map of keys and values, where the keys are snake_case.\nReturns the `heading}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Heading.html#new!/1"},{"type":"function","title":"NLdoc.Spec.Heading.resource_type/0","doc":"","ref":"NLdoc.Spec.Heading.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.Heading.t/0","doc":"","ref":"NLdoc.Spec.Heading.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Heading.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.Heading.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.Heading.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.Heading.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.Heading.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.Heading.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.Image","doc":"This module defines the Ecto schema for the NLdoc spec Image object.","ref":"NLdoc.Spec.Image.html"},{"type":"function","title":"NLdoc.Spec.Image.changeset/2","doc":"","ref":"NLdoc.Spec.Image.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.Image.new/1","doc":"This function creates a new `NLdoc.Spec.Image` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, image}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Image.html#new/1"},{"type":"function","title":"NLdoc.Spec.Image.new!/1","doc":"This function creates a new `NLdoc.Spec.Image` struct from a map of keys and values, where the keys are snake_case.\nReturns the `image}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Image.html#new!/1"},{"type":"function","title":"NLdoc.Spec.Image.resource_type/0","doc":"","ref":"NLdoc.Spec.Image.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.Image.t/0","doc":"","ref":"NLdoc.Spec.Image.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Image.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.Image.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.Image.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.Image.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.Image.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.Image.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.IntegerDescriptor","doc":"This module defines the Ecto schema for the NLdoc spec IntegerDescriptor object.","ref":"NLdoc.Spec.IntegerDescriptor.html"},{"type":"function","title":"NLdoc.Spec.IntegerDescriptor.changeset/2","doc":"","ref":"NLdoc.Spec.IntegerDescriptor.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.IntegerDescriptor.new/1","doc":"This function creates a new `NLdoc.Spec.IntegerDescriptor` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, integer_descriptor}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.IntegerDescriptor.html#new/1"},{"type":"function","title":"NLdoc.Spec.IntegerDescriptor.new!/1","doc":"This function creates a new `NLdoc.Spec.IntegerDescriptor` struct from a map of keys and values, where the keys are snake_case.\nReturns the `integer_descriptor}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.IntegerDescriptor.html#new!/1"},{"type":"function","title":"NLdoc.Spec.IntegerDescriptor.resource_type/0","doc":"","ref":"NLdoc.Spec.IntegerDescriptor.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.IntegerDescriptor.t/0","doc":"","ref":"NLdoc.Spec.IntegerDescriptor.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.IntegerDescriptor.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.IntegerDescriptor.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.IntegerDescriptor.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.IntegerDescriptor.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.IntegerDescriptor.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.IntegerDescriptor.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.Link","doc":"This module defines the Ecto schema for the NLdoc spec Link object.","ref":"NLdoc.Spec.Link.html"},{"type":"function","title":"NLdoc.Spec.Link.changeset/2","doc":"","ref":"NLdoc.Spec.Link.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.Link.new/1","doc":"This function creates a new `NLdoc.Spec.Link` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, link}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Link.html#new/1"},{"type":"function","title":"NLdoc.Spec.Link.new!/1","doc":"This function creates a new `NLdoc.Spec.Link` struct from a map of keys and values, where the keys are snake_case.\nReturns the `link}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Link.html#new!/1"},{"type":"function","title":"NLdoc.Spec.Link.resource_type/0","doc":"","ref":"NLdoc.Spec.Link.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.Link.t/0","doc":"","ref":"NLdoc.Spec.Link.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Link.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.Link.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.Link.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.Link.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.Link.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.Link.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.ListItem","doc":"This module defines the Ecto schema for the NLdoc spec ListItem object.","ref":"NLdoc.Spec.ListItem.html"},{"type":"function","title":"NLdoc.Spec.ListItem.changeset/2","doc":"","ref":"NLdoc.Spec.ListItem.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.ListItem.new/1","doc":"This function creates a new `NLdoc.Spec.ListItem` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, list_item}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.ListItem.html#new/1"},{"type":"function","title":"NLdoc.Spec.ListItem.new!/1","doc":"This function creates a new `NLdoc.Spec.ListItem` struct from a map of keys and values, where the keys are snake_case.\nReturns the `list_item}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.ListItem.html#new!/1"},{"type":"function","title":"NLdoc.Spec.ListItem.resource_type/0","doc":"","ref":"NLdoc.Spec.ListItem.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.ListItem.t/0","doc":"","ref":"NLdoc.Spec.ListItem.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.ListItem.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.ListItem.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.ListItem.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.ListItem.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.ListItem.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.ListItem.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.NumberDescriptor","doc":"This module defines the Ecto schema for the NLdoc spec NumberDescriptor object.","ref":"NLdoc.Spec.NumberDescriptor.html"},{"type":"function","title":"NLdoc.Spec.NumberDescriptor.changeset/2","doc":"","ref":"NLdoc.Spec.NumberDescriptor.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.NumberDescriptor.new/1","doc":"This function creates a new `NLdoc.Spec.NumberDescriptor` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, number_descriptor}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.NumberDescriptor.html#new/1"},{"type":"function","title":"NLdoc.Spec.NumberDescriptor.new!/1","doc":"This function creates a new `NLdoc.Spec.NumberDescriptor` struct from a map of keys and values, where the keys are snake_case.\nReturns the `number_descriptor}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.NumberDescriptor.html#new!/1"},{"type":"function","title":"NLdoc.Spec.NumberDescriptor.resource_type/0","doc":"","ref":"NLdoc.Spec.NumberDescriptor.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.NumberDescriptor.t/0","doc":"","ref":"NLdoc.Spec.NumberDescriptor.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.NumberDescriptor.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.NumberDescriptor.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.NumberDescriptor.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.NumberDescriptor.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.NumberDescriptor.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.NumberDescriptor.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.ObjectDescriptor","doc":"This module defines the Ecto schema for the NLdoc spec ObjectDescriptor object.","ref":"NLdoc.Spec.ObjectDescriptor.html"},{"type":"function","title":"NLdoc.Spec.ObjectDescriptor.changeset/2","doc":"","ref":"NLdoc.Spec.ObjectDescriptor.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.ObjectDescriptor.new/1","doc":"This function creates a new `NLdoc.Spec.ObjectDescriptor` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, object_descriptor}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.ObjectDescriptor.html#new/1"},{"type":"function","title":"NLdoc.Spec.ObjectDescriptor.new!/1","doc":"This function creates a new `NLdoc.Spec.ObjectDescriptor` struct from a map of keys and values, where the keys are snake_case.\nReturns the `object_descriptor}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.ObjectDescriptor.html#new!/1"},{"type":"function","title":"NLdoc.Spec.ObjectDescriptor.resource_type/0","doc":"","ref":"NLdoc.Spec.ObjectDescriptor.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.ObjectDescriptor.t/0","doc":"","ref":"NLdoc.Spec.ObjectDescriptor.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.ObjectDescriptor.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.ObjectDescriptor.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.ObjectDescriptor.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.ObjectDescriptor.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.ObjectDescriptor.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.ObjectDescriptor.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.OrderedList","doc":"This module defines the Ecto schema for the NLdoc spec OrderedList object.","ref":"NLdoc.Spec.OrderedList.html"},{"type":"function","title":"NLdoc.Spec.OrderedList.changeset/2","doc":"","ref":"NLdoc.Spec.OrderedList.html#changeset/2"},{"type":"macro","title":"NLdoc.Spec.OrderedList.is_ordered_list_style/1","doc":"","ref":"NLdoc.Spec.OrderedList.html#is_ordered_list_style/1"},{"type":"function","title":"NLdoc.Spec.OrderedList.new/1","doc":"This function creates a new `NLdoc.Spec.OrderedList` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, ordered_list}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.OrderedList.html#new/1"},{"type":"function","title":"NLdoc.Spec.OrderedList.new!/1","doc":"This function creates a new `NLdoc.Spec.OrderedList` struct from a map of keys and values, where the keys are snake_case.\nReturns the `ordered_list}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.OrderedList.html#new!/1"},{"type":"function","title":"NLdoc.Spec.OrderedList.resource_type/0","doc":"","ref":"NLdoc.Spec.OrderedList.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.OrderedList.style_type/0","doc":"","ref":"NLdoc.Spec.OrderedList.html#t:style_type/0"},{"type":"type","title":"NLdoc.Spec.OrderedList.t/0","doc":"","ref":"NLdoc.Spec.OrderedList.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.OrderedList.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.OrderedList.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.OrderedList.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.OrderedList.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.OrderedList.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.OrderedList.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.Paragraph","doc":"This module defines the Ecto schema for the NLdoc spec Paragraph object.","ref":"NLdoc.Spec.Paragraph.html"},{"type":"function","title":"NLdoc.Spec.Paragraph.changeset/2","doc":"","ref":"NLdoc.Spec.Paragraph.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.Paragraph.new/1","doc":"This function creates a new `NLdoc.Spec.Paragraph` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, paragraph}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Paragraph.html#new/1"},{"type":"function","title":"NLdoc.Spec.Paragraph.new!/1","doc":"This function creates a new `NLdoc.Spec.Paragraph` struct from a map of keys and values, where the keys are snake_case.\nReturns the `paragraph}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Paragraph.html#new!/1"},{"type":"function","title":"NLdoc.Spec.Paragraph.resource_type/0","doc":"","ref":"NLdoc.Spec.Paragraph.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.Paragraph.t/0","doc":"","ref":"NLdoc.Spec.Paragraph.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Paragraph.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.Paragraph.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.Paragraph.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.Paragraph.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.Paragraph.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.Paragraph.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.Preformatted","doc":"This module defines the Ecto schema for the NLdoc spec Preformatted object.","ref":"NLdoc.Spec.Preformatted.html"},{"type":"function","title":"NLdoc.Spec.Preformatted.changeset/2","doc":"","ref":"NLdoc.Spec.Preformatted.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.Preformatted.new/1","doc":"This function creates a new `NLdoc.Spec.Preformatted` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, preformatted}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Preformatted.html#new/1"},{"type":"function","title":"NLdoc.Spec.Preformatted.new!/1","doc":"This function creates a new `NLdoc.Spec.Preformatted` struct from a map of keys and values, where the keys are snake_case.\nReturns the `preformatted}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Preformatted.html#new!/1"},{"type":"function","title":"NLdoc.Spec.Preformatted.resource_type/0","doc":"","ref":"NLdoc.Spec.Preformatted.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.Preformatted.t/0","doc":"","ref":"NLdoc.Spec.Preformatted.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Preformatted.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.Preformatted.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.Preformatted.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.Preformatted.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.Preformatted.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.Preformatted.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.Schema","doc":"This module sets some defaults over the Ecto schema for the NLdoc spec.\n\n1. Use this in all schemas for the NLdoc spec, instead of `use Ecto.Schema` or `use TypedEctoSchema`:\n    `use NLdoc.Spec.Schema, type: \"https://spec.nldoc.nl/Resource/Foo\"`\n2. Implement the `changeset/2` function in the schema module.\n3. Make sure to add `@cast_opts` to all calls to `cast/4` or `cast_embed/3` or `cast_polymorphic_embed/3`,\n   as it ensures strings that only contain whitespace are accepted as valid.\n\nNote: the `type` option is required and must be a string. It is the resource type of the schema.\nIt will be available as `@resource_type` in the schema module and through the `resource_type/0` function on the schema module.","ref":"NLdoc.Spec.Schema.html"},{"type":"function","title":"NLdoc.Spec.Schema.collect_errors/1","doc":"Collects all errors from a changeset and its nested changesets into a flat map,\nmapping the full JSON path of each property to its error.","ref":"NLdoc.Spec.Schema.html#collect_errors/1"},{"type":"function","title":"Example - NLdoc.Spec.Schema.collect_errors/1","doc":"iex> changeset = %Ecto.Changeset{\n    ...>   changes: [\n    ...>     descriptors: [\n    ...>       %Ecto.Changeset{errors: [url: {\"is invalid\", [validation: :invalid_url]}]}\n    ...>     ]\n    ...>   ],\n    ...>   errors: [\n    ...>     name: {\"is invalid\", [type: :string]}\n    ...>   ]\n    ...> }\n    iex> NLdoc.Spec.Schema.collect_errors(changeset)\n    %{\n      name: {\"is invalid\", [type: :string]},\n      \"descriptors[0].url\": {\"is invalid\", [validation: :invalid_url]}\n    }","ref":"NLdoc.Spec.Schema.html#collect_errors/1-example"},{"type":"function","title":"NLdoc.Spec.Schema.collect_errors/2","doc":"","ref":"NLdoc.Spec.Schema.html#collect_errors/2"},{"type":"macro","title":"NLdoc.Spec.Schema.def_constructor/1","doc":"This macro defines the `new/1` and `new!/1` functions for the schema module that create a new document from a template,\nwhich essentially functions like an input-validating constructor for the struct defined by the schema module.","ref":"NLdoc.Spec.Schema.html#def_constructor/1"},{"type":"type","title":"NLdoc.Spec.Schema.errors/0","doc":"","ref":"NLdoc.Spec.Schema.html#t:errors/0"},{"type":"macro","title":"NLdoc.Spec.Schema.map/1","doc":"This macro maps a list of modules to a list of tuples with the module's resource type and the module itself.\nIt's a macro because Ecto's schema definitions require this mapping to be done at compile time.\n\nExample:\n\n    > NLdoc.Schema.map([Heading, Image])\n    [\n      \"https://spec.nldoc.nl/Resource/Heading\": Heading,\n      \"https://spec.nldoc.nl/Resource/Image\": Image\n    ]","ref":"NLdoc.Spec.Schema.html#map/1"},{"type":"function","title":"NLdoc.Spec.Schema.module_exists?/1","doc":"Returns true if the given module is an existing module.","ref":"NLdoc.Spec.Schema.html#module_exists?/1"},{"type":"function","title":"NLdoc.Spec.Schema.schema_module?/1","doc":"Returns true for a module that is a schema module, i.e. it has a `new/1` and a `changeset/2` function.","ref":"NLdoc.Spec.Schema.html#schema_module?/1"},{"type":"function","title":"NLdoc.Spec.Schema.validate_url/2","doc":"This function validates whether a string is a valid URL, returning nil if it's valid\nand an `Ecto.Changeset.error()` if it's not.","ref":"NLdoc.Spec.Schema.html#validate_url/2"},{"type":"function","title":"Examples - NLdoc.Spec.Schema.validate_url/2","doc":"iex> NLdoc.Spec.Schema.validate_url(\"http://localhost:4000\")\n    nil\n\n    iex> NLdoc.Spec.Schema.validate_url(\"https://nldoc.nl/path/to/resource?query=string#fragment\")\n    nil\n\n    iex> NLdoc.Spec.Schema.validate_url(\"https://no-tld\")\n    nil\n\n    iex> NLdoc.Spec.Schema.validate_url(\"test\")\n    {\"is not a valid URL\", error: [invalid_scheme: nil]}\n\n    iex> NLdoc.Spec.Schema.validate_url(\"/path/to/resource\")\n    {\"is not a valid URL\", error: [invalid_scheme: nil, invalid_host: \"/path/to/resource\"]}","ref":"NLdoc.Spec.Schema.html#validate_url/2-examples"},{"type":"type","title":"NLdoc.Spec.Schema.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.Schema.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.StringDescriptor","doc":"This module defines the Ecto schema for the NLdoc spec StringDescriptor object.","ref":"NLdoc.Spec.StringDescriptor.html"},{"type":"function","title":"NLdoc.Spec.StringDescriptor.changeset/2","doc":"","ref":"NLdoc.Spec.StringDescriptor.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.StringDescriptor.new/1","doc":"This function creates a new `NLdoc.Spec.StringDescriptor` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, string_descriptor}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.StringDescriptor.html#new/1"},{"type":"function","title":"NLdoc.Spec.StringDescriptor.new!/1","doc":"This function creates a new `NLdoc.Spec.StringDescriptor` struct from a map of keys and values, where the keys are snake_case.\nReturns the `string_descriptor}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.StringDescriptor.html#new!/1"},{"type":"function","title":"NLdoc.Spec.StringDescriptor.resource_type/0","doc":"","ref":"NLdoc.Spec.StringDescriptor.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.StringDescriptor.t/0","doc":"","ref":"NLdoc.Spec.StringDescriptor.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.StringDescriptor.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.StringDescriptor.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.StringDescriptor.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.StringDescriptor.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.StringDescriptor.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.StringDescriptor.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.Table","doc":"This module defines the Ecto schema for the NLdoc spec Table object.","ref":"NLdoc.Spec.Table.html"},{"type":"function","title":"NLdoc.Spec.Table.changeset/2","doc":"","ref":"NLdoc.Spec.Table.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.Table.new/1","doc":"This function creates a new `NLdoc.Spec.Table` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, table}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Table.html#new/1"},{"type":"function","title":"NLdoc.Spec.Table.new!/1","doc":"This function creates a new `NLdoc.Spec.Table` struct from a map of keys and values, where the keys are snake_case.\nReturns the `table}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Table.html#new!/1"},{"type":"function","title":"NLdoc.Spec.Table.resource_type/0","doc":"","ref":"NLdoc.Spec.Table.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.Table.t/0","doc":"","ref":"NLdoc.Spec.Table.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Table.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.Table.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.Table.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.Table.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.Table.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.Table.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.TableCell","doc":"This module defines the Ecto schema for the NLdoc spec TableCell object.","ref":"NLdoc.Spec.TableCell.html"},{"type":"function","title":"NLdoc.Spec.TableCell.changeset/2","doc":"","ref":"NLdoc.Spec.TableCell.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.TableCell.new/1","doc":"This function creates a new `NLdoc.Spec.TableCell` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, table_cell}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.TableCell.html#new/1"},{"type":"function","title":"NLdoc.Spec.TableCell.new!/1","doc":"This function creates a new `NLdoc.Spec.TableCell` struct from a map of keys and values, where the keys are snake_case.\nReturns the `table_cell}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.TableCell.html#new!/1"},{"type":"function","title":"NLdoc.Spec.TableCell.resource_type/0","doc":"","ref":"NLdoc.Spec.TableCell.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.TableCell.t/0","doc":"","ref":"NLdoc.Spec.TableCell.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.TableCell.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.TableCell.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.TableCell.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.TableCell.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.TableCell.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.TableCell.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.TableHeader","doc":"This module defines the Ecto schema for the NLdoc spec TableHeader object.","ref":"NLdoc.Spec.TableHeader.html"},{"type":"function","title":"NLdoc.Spec.TableHeader.changeset/2","doc":"","ref":"NLdoc.Spec.TableHeader.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.TableHeader.new/1","doc":"This function creates a new `NLdoc.Spec.TableHeader` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, table_header}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.TableHeader.html#new/1"},{"type":"function","title":"NLdoc.Spec.TableHeader.new!/1","doc":"This function creates a new `NLdoc.Spec.TableHeader` struct from a map of keys and values, where the keys are snake_case.\nReturns the `table_header}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.TableHeader.html#new!/1"},{"type":"function","title":"NLdoc.Spec.TableHeader.resource_type/0","doc":"","ref":"NLdoc.Spec.TableHeader.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.TableHeader.t/0","doc":"","ref":"NLdoc.Spec.TableHeader.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.TableHeader.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.TableHeader.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.TableHeader.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.TableHeader.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.TableHeader.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.TableHeader.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.TableRow","doc":"This module defines the Ecto schema for the NLdoc spec TableRow object.","ref":"NLdoc.Spec.TableRow.html"},{"type":"function","title":"NLdoc.Spec.TableRow.at_least_one_element?/1","doc":"","ref":"NLdoc.Spec.TableRow.html#at_least_one_element?/1"},{"type":"function","title":"NLdoc.Spec.TableRow.changeset/2","doc":"","ref":"NLdoc.Spec.TableRow.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.TableRow.new/1","doc":"This function creates a new `NLdoc.Spec.TableRow` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, table_row}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.TableRow.html#new/1"},{"type":"function","title":"NLdoc.Spec.TableRow.new!/1","doc":"This function creates a new `NLdoc.Spec.TableRow` struct from a map of keys and values, where the keys are snake_case.\nReturns the `table_row}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.TableRow.html#new!/1"},{"type":"function","title":"NLdoc.Spec.TableRow.resource_type/0","doc":"","ref":"NLdoc.Spec.TableRow.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.TableRow.t/0","doc":"","ref":"NLdoc.Spec.TableRow.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.TableRow.validate_has_children/2","doc":"","ref":"NLdoc.Spec.TableRow.html#validate_has_children/2"},{"type":"function","title":"NLdoc.Spec.TableRow.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.TableRow.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.TableRow.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.TableRow.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.TableRow.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.TableRow.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.Template","doc":"This module is a template for creating new NLdoc spec resource schemas.\n\nTo create a new resource schema:\n\n1. Copy this file to a new file in the same directory, renaming it to the name of the new resource in snake_case.\n2. Replace all occurrences of `Template` in that file with the name of the new resource.\n3. Add the fields for this resource to the `typed_embedded_schema`.\n4. Update the `changeset` function to cast and validate the new fields.\n5. Add the new resource type to the `NLdoc.Spec.Type` enum.\n6. Add the `t` type to the `NLdoc.Spec.object` type.\n7. Remove this section of the moduledoc up to and including `---`.\n8. Now you can use the new resource in other schemas, e.g. add it to the possible children of `NLdoc.Spec.Document`.\n\n---\n\nThis module defines the Ecto schema for the NLdoc spec Template object.","ref":"NLdoc.Spec.Template.html"},{"type":"function","title":"NLdoc.Spec.Template.changeset/2","doc":"","ref":"NLdoc.Spec.Template.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.Template.new/1","doc":"This function creates a new `NLdoc.Spec.Template` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, template}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Template.html#new/1"},{"type":"function","title":"NLdoc.Spec.Template.new!/1","doc":"This function creates a new `NLdoc.Spec.Template` struct from a map of keys and values, where the keys are snake_case.\nReturns the `template}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Template.html#new!/1"},{"type":"function","title":"NLdoc.Spec.Template.resource_type/0","doc":"","ref":"NLdoc.Spec.Template.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.Template.t/0","doc":"","ref":"NLdoc.Spec.Template.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Template.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.Template.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.Template.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.Template.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.Template.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.Template.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.Text","doc":"This module defines the Ecto schema for the NLdoc spec Text object.","ref":"NLdoc.Spec.Text.html"},{"type":"function","title":"NLdoc.Spec.Text.changeset/2","doc":"","ref":"NLdoc.Spec.Text.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.Text.new/1","doc":"This function creates a new `NLdoc.Spec.Text` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, text}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Text.html#new/1"},{"type":"function","title":"NLdoc.Spec.Text.new!/1","doc":"This function creates a new `NLdoc.Spec.Text` struct from a map of keys and values, where the keys are snake_case.\nReturns the `text}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Text.html#new!/1"},{"type":"function","title":"NLdoc.Spec.Text.resource_type/0","doc":"","ref":"NLdoc.Spec.Text.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.Text.t/0","doc":"","ref":"NLdoc.Spec.Text.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Text.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.Text.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.Text.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.Text.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.Text.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.Text.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.Type","doc":"","ref":"NLdoc.Spec.Type.html"},{"type":"function","title":"NLdoc.Spec.Type.cast/1","doc":"","ref":"NLdoc.Spec.Type.html#cast/1"},{"type":"function","title":"NLdoc.Spec.Type.default/0","doc":"","ref":"NLdoc.Spec.Type.html#default/0"},{"type":"function","title":"NLdoc.Spec.Type.dump/1","doc":"","ref":"NLdoc.Spec.Type.html#dump/1"},{"type":"function","title":"NLdoc.Spec.Type.embed_as/1","doc":"","ref":"NLdoc.Spec.Type.html#embed_as/1"},{"type":"function","title":"NLdoc.Spec.Type.enums/0","doc":"","ref":"NLdoc.Spec.Type.html#enums/0"},{"type":"function","title":"NLdoc.Spec.Type.equal?/2","doc":"","ref":"NLdoc.Spec.Type.html#equal?/2"},{"type":"function","title":"NLdoc.Spec.Type.from/1","doc":"","ref":"NLdoc.Spec.Type.html#from/1"},{"type":"function","title":"NLdoc.Spec.Type.load/1","doc":"","ref":"NLdoc.Spec.Type.html#load/1"},{"type":"function","title":"NLdoc.Spec.Type.options/0","doc":"","ref":"NLdoc.Spec.Type.html#options/0"},{"type":"type","title":"NLdoc.Spec.Type.t/0","doc":"","ref":"NLdoc.Spec.Type.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.type/0","doc":"","ref":"NLdoc.Spec.Type.html#type/0"},{"type":"function","title":"NLdoc.Spec.Type.validate/3","doc":"","ref":"NLdoc.Spec.Type.html#validate/3"},{"type":"function","title":"NLdoc.Spec.Type.value/1","doc":"","ref":"NLdoc.Spec.Type.html#value/1"},{"type":"function","title":"NLdoc.Spec.Type.values/0","doc":"","ref":"NLdoc.Spec.Type.html#values/0"},{"type":"module","title":"NLdoc.Spec.Type.Asset","doc":"","ref":"NLdoc.Spec.Type.Asset.html"},{"type":"function","title":"NLdoc.Spec.Type.Asset.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Asset.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.Asset.t/0","doc":"","ref":"NLdoc.Spec.Type.Asset.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.Asset.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Asset.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.Asset.value/0","doc":"","ref":"NLdoc.Spec.Type.Asset.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.BlockQuotation","doc":"","ref":"NLdoc.Spec.Type.BlockQuotation.html"},{"type":"function","title":"NLdoc.Spec.Type.BlockQuotation.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.BlockQuotation.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.BlockQuotation.t/0","doc":"","ref":"NLdoc.Spec.Type.BlockQuotation.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.BlockQuotation.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.BlockQuotation.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.BlockQuotation.value/0","doc":"","ref":"NLdoc.Spec.Type.BlockQuotation.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.BooleanDescriptor","doc":"","ref":"NLdoc.Spec.Type.BooleanDescriptor.html"},{"type":"function","title":"NLdoc.Spec.Type.BooleanDescriptor.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.BooleanDescriptor.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.BooleanDescriptor.t/0","doc":"","ref":"NLdoc.Spec.Type.BooleanDescriptor.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.BooleanDescriptor.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.BooleanDescriptor.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.BooleanDescriptor.value/0","doc":"","ref":"NLdoc.Spec.Type.BooleanDescriptor.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.DefinitionDetails","doc":"","ref":"NLdoc.Spec.Type.DefinitionDetails.html"},{"type":"function","title":"NLdoc.Spec.Type.DefinitionDetails.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.DefinitionDetails.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.DefinitionDetails.t/0","doc":"","ref":"NLdoc.Spec.Type.DefinitionDetails.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.DefinitionDetails.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.DefinitionDetails.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.DefinitionDetails.value/0","doc":"","ref":"NLdoc.Spec.Type.DefinitionDetails.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.DefinitionList","doc":"","ref":"NLdoc.Spec.Type.DefinitionList.html"},{"type":"function","title":"NLdoc.Spec.Type.DefinitionList.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.DefinitionList.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.DefinitionList.t/0","doc":"","ref":"NLdoc.Spec.Type.DefinitionList.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.DefinitionList.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.DefinitionList.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.DefinitionList.value/0","doc":"","ref":"NLdoc.Spec.Type.DefinitionList.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.DefinitionTerm","doc":"","ref":"NLdoc.Spec.Type.DefinitionTerm.html"},{"type":"function","title":"NLdoc.Spec.Type.DefinitionTerm.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.DefinitionTerm.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.DefinitionTerm.t/0","doc":"","ref":"NLdoc.Spec.Type.DefinitionTerm.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.DefinitionTerm.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.DefinitionTerm.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.DefinitionTerm.value/0","doc":"","ref":"NLdoc.Spec.Type.DefinitionTerm.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.Document","doc":"","ref":"NLdoc.Spec.Type.Document.html"},{"type":"function","title":"NLdoc.Spec.Type.Document.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Document.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.Document.t/0","doc":"","ref":"NLdoc.Spec.Type.Document.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.Document.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Document.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.Document.value/0","doc":"","ref":"NLdoc.Spec.Type.Document.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.Footnote","doc":"","ref":"NLdoc.Spec.Type.Footnote.html"},{"type":"function","title":"NLdoc.Spec.Type.Footnote.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Footnote.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.Footnote.t/0","doc":"","ref":"NLdoc.Spec.Type.Footnote.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.Footnote.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Footnote.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.Footnote.value/0","doc":"","ref":"NLdoc.Spec.Type.Footnote.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.FootnoteReference","doc":"","ref":"NLdoc.Spec.Type.FootnoteReference.html"},{"type":"function","title":"NLdoc.Spec.Type.FootnoteReference.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.FootnoteReference.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.FootnoteReference.t/0","doc":"","ref":"NLdoc.Spec.Type.FootnoteReference.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.FootnoteReference.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.FootnoteReference.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.FootnoteReference.value/0","doc":"","ref":"NLdoc.Spec.Type.FootnoteReference.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.Heading","doc":"","ref":"NLdoc.Spec.Type.Heading.html"},{"type":"function","title":"NLdoc.Spec.Type.Heading.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Heading.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.Heading.t/0","doc":"","ref":"NLdoc.Spec.Type.Heading.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.Heading.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Heading.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.Heading.value/0","doc":"","ref":"NLdoc.Spec.Type.Heading.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.Image","doc":"","ref":"NLdoc.Spec.Type.Image.html"},{"type":"function","title":"NLdoc.Spec.Type.Image.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Image.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.Image.t/0","doc":"","ref":"NLdoc.Spec.Type.Image.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.Image.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Image.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.Image.value/0","doc":"","ref":"NLdoc.Spec.Type.Image.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.IntegerDescriptor","doc":"","ref":"NLdoc.Spec.Type.IntegerDescriptor.html"},{"type":"function","title":"NLdoc.Spec.Type.IntegerDescriptor.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.IntegerDescriptor.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.IntegerDescriptor.t/0","doc":"","ref":"NLdoc.Spec.Type.IntegerDescriptor.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.IntegerDescriptor.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.IntegerDescriptor.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.IntegerDescriptor.value/0","doc":"","ref":"NLdoc.Spec.Type.IntegerDescriptor.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.Link","doc":"","ref":"NLdoc.Spec.Type.Link.html"},{"type":"function","title":"NLdoc.Spec.Type.Link.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Link.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.Link.t/0","doc":"","ref":"NLdoc.Spec.Type.Link.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.Link.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Link.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.Link.value/0","doc":"","ref":"NLdoc.Spec.Type.Link.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.ListItem","doc":"","ref":"NLdoc.Spec.Type.ListItem.html"},{"type":"function","title":"NLdoc.Spec.Type.ListItem.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.ListItem.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.ListItem.t/0","doc":"","ref":"NLdoc.Spec.Type.ListItem.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.ListItem.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.ListItem.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.ListItem.value/0","doc":"","ref":"NLdoc.Spec.Type.ListItem.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.NumberDescriptor","doc":"","ref":"NLdoc.Spec.Type.NumberDescriptor.html"},{"type":"function","title":"NLdoc.Spec.Type.NumberDescriptor.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.NumberDescriptor.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.NumberDescriptor.t/0","doc":"","ref":"NLdoc.Spec.Type.NumberDescriptor.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.NumberDescriptor.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.NumberDescriptor.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.NumberDescriptor.value/0","doc":"","ref":"NLdoc.Spec.Type.NumberDescriptor.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.ObjectDescriptor","doc":"","ref":"NLdoc.Spec.Type.ObjectDescriptor.html"},{"type":"function","title":"NLdoc.Spec.Type.ObjectDescriptor.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.ObjectDescriptor.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.ObjectDescriptor.t/0","doc":"","ref":"NLdoc.Spec.Type.ObjectDescriptor.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.ObjectDescriptor.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.ObjectDescriptor.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.ObjectDescriptor.value/0","doc":"","ref":"NLdoc.Spec.Type.ObjectDescriptor.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.OrderedList","doc":"","ref":"NLdoc.Spec.Type.OrderedList.html"},{"type":"function","title":"NLdoc.Spec.Type.OrderedList.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.OrderedList.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.OrderedList.t/0","doc":"","ref":"NLdoc.Spec.Type.OrderedList.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.OrderedList.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.OrderedList.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.OrderedList.value/0","doc":"","ref":"NLdoc.Spec.Type.OrderedList.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.Paragraph","doc":"","ref":"NLdoc.Spec.Type.Paragraph.html"},{"type":"function","title":"NLdoc.Spec.Type.Paragraph.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Paragraph.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.Paragraph.t/0","doc":"","ref":"NLdoc.Spec.Type.Paragraph.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.Paragraph.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Paragraph.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.Paragraph.value/0","doc":"","ref":"NLdoc.Spec.Type.Paragraph.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.Preformatted","doc":"","ref":"NLdoc.Spec.Type.Preformatted.html"},{"type":"function","title":"NLdoc.Spec.Type.Preformatted.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Preformatted.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.Preformatted.t/0","doc":"","ref":"NLdoc.Spec.Type.Preformatted.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.Preformatted.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Preformatted.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.Preformatted.value/0","doc":"","ref":"NLdoc.Spec.Type.Preformatted.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.StringDescriptor","doc":"","ref":"NLdoc.Spec.Type.StringDescriptor.html"},{"type":"function","title":"NLdoc.Spec.Type.StringDescriptor.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.StringDescriptor.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.StringDescriptor.t/0","doc":"","ref":"NLdoc.Spec.Type.StringDescriptor.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.StringDescriptor.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.StringDescriptor.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.StringDescriptor.value/0","doc":"","ref":"NLdoc.Spec.Type.StringDescriptor.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.Table","doc":"","ref":"NLdoc.Spec.Type.Table.html"},{"type":"function","title":"NLdoc.Spec.Type.Table.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Table.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.Table.t/0","doc":"","ref":"NLdoc.Spec.Type.Table.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.Table.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Table.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.Table.value/0","doc":"","ref":"NLdoc.Spec.Type.Table.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.TableCell","doc":"","ref":"NLdoc.Spec.Type.TableCell.html"},{"type":"function","title":"NLdoc.Spec.Type.TableCell.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.TableCell.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.TableCell.t/0","doc":"","ref":"NLdoc.Spec.Type.TableCell.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.TableCell.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.TableCell.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.TableCell.value/0","doc":"","ref":"NLdoc.Spec.Type.TableCell.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.TableHeader","doc":"","ref":"NLdoc.Spec.Type.TableHeader.html"},{"type":"function","title":"NLdoc.Spec.Type.TableHeader.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.TableHeader.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.TableHeader.t/0","doc":"","ref":"NLdoc.Spec.Type.TableHeader.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.TableHeader.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.TableHeader.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.TableHeader.value/0","doc":"","ref":"NLdoc.Spec.Type.TableHeader.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.TableRow","doc":"","ref":"NLdoc.Spec.Type.TableRow.html"},{"type":"function","title":"NLdoc.Spec.Type.TableRow.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.TableRow.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.TableRow.t/0","doc":"","ref":"NLdoc.Spec.Type.TableRow.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.TableRow.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.TableRow.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.TableRow.value/0","doc":"","ref":"NLdoc.Spec.Type.TableRow.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.Text","doc":"","ref":"NLdoc.Spec.Type.Text.html"},{"type":"function","title":"NLdoc.Spec.Type.Text.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Text.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.Text.t/0","doc":"","ref":"NLdoc.Spec.Type.Text.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.Text.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Text.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.Text.value/0","doc":"","ref":"NLdoc.Spec.Type.Text.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.UnorderedList","doc":"","ref":"NLdoc.Spec.Type.UnorderedList.html"},{"type":"function","title":"NLdoc.Spec.Type.UnorderedList.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.UnorderedList.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.UnorderedList.t/0","doc":"","ref":"NLdoc.Spec.Type.UnorderedList.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.UnorderedList.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.UnorderedList.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.UnorderedList.value/0","doc":"","ref":"NLdoc.Spec.Type.UnorderedList.html#value/0"},{"type":"module","title":"NLdoc.Spec.Type.Validation","doc":"","ref":"NLdoc.Spec.Type.Validation.html"},{"type":"function","title":"NLdoc.Spec.Type.Validation.downcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Validation.html#downcase_value/0"},{"type":"type","title":"NLdoc.Spec.Type.Validation.t/0","doc":"","ref":"NLdoc.Spec.Type.Validation.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Type.Validation.upcase_value/0","doc":"","ref":"NLdoc.Spec.Type.Validation.html#upcase_value/0"},{"type":"function","title":"NLdoc.Spec.Type.Validation.value/0","doc":"","ref":"NLdoc.Spec.Type.Validation.html#value/0"},{"type":"module","title":"NLdoc.Spec.UnorderedList","doc":"This module defines the Ecto schema for the NLdoc spec UnorderedList object.","ref":"NLdoc.Spec.UnorderedList.html"},{"type":"function","title":"NLdoc.Spec.UnorderedList.changeset/2","doc":"","ref":"NLdoc.Spec.UnorderedList.html#changeset/2"},{"type":"macro","title":"NLdoc.Spec.UnorderedList.is_unordered_list_style/1","doc":"","ref":"NLdoc.Spec.UnorderedList.html#is_unordered_list_style/1"},{"type":"function","title":"NLdoc.Spec.UnorderedList.new/1","doc":"This function creates a new `NLdoc.Spec.UnorderedList` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, unordered_list}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.UnorderedList.html#new/1"},{"type":"function","title":"NLdoc.Spec.UnorderedList.new!/1","doc":"This function creates a new `NLdoc.Spec.UnorderedList` struct from a map of keys and values, where the keys are snake_case.\nReturns the `unordered_list}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.UnorderedList.html#new!/1"},{"type":"function","title":"NLdoc.Spec.UnorderedList.resource_type/0","doc":"","ref":"NLdoc.Spec.UnorderedList.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.UnorderedList.style_type/0","doc":"","ref":"NLdoc.Spec.UnorderedList.html#t:style_type/0"},{"type":"type","title":"NLdoc.Spec.UnorderedList.t/0","doc":"","ref":"NLdoc.Spec.UnorderedList.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.UnorderedList.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.UnorderedList.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.UnorderedList.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.UnorderedList.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.UnorderedList.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.UnorderedList.html#t:validate_url_opt/0"},{"type":"module","title":"NLdoc.Spec.Validation","doc":"This module defines the Ecto schema for the NLdoc Validation spec Validation object.","ref":"NLdoc.Spec.Validation.html"},{"type":"function","title":"NLdoc.Spec.Validation.changeset/2","doc":"","ref":"NLdoc.Spec.Validation.html#changeset/2"},{"type":"function","title":"NLdoc.Spec.Validation.new/1","doc":"This function creates a new `NLdoc.Spec.Validation` struct from a map of keys and values, where the keys are snake_case.\nReturns a tuple with either `{:ok, validation}` or `{:error, changeset}`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Validation.html#new/1"},{"type":"function","title":"NLdoc.Spec.Validation.new!/1","doc":"This function creates a new `NLdoc.Spec.Validation` struct from a map of keys and values, where the keys are snake_case.\nReturns the `validation}` object or raises an `Ecto.CastError`.\n\nNote: If you want to use a map with camelCase keys, use `NLdoc.Util.Recase.to_snake/1`\nto convert them to snake_case before passing them to the constructor.","ref":"NLdoc.Spec.Validation.html#new!/1"},{"type":"function","title":"NLdoc.Spec.Validation.resource_type/0","doc":"","ref":"NLdoc.Spec.Validation.html#resource_type/0"},{"type":"type","title":"NLdoc.Spec.Validation.t/0","doc":"","ref":"NLdoc.Spec.Validation.html#t:t/0"},{"type":"function","title":"NLdoc.Spec.Validation.validate_url/3","doc":"This validation function can be used in `changeset/2` implementations to ensure that\nthe value for a specific field is a valid URL.","ref":"NLdoc.Spec.Validation.html#validate_url/3"},{"type":"function","title":"Options - NLdoc.Spec.Validation.validate_url/3","doc":"* `:message` - The error message to use when the URL is invalid.\n* `:allow_relative` - If set to `true`, relative URLs are allowed. Default is `false`.","ref":"NLdoc.Spec.Validation.html#validate_url/3-options"},{"type":"type","title":"NLdoc.Spec.Validation.validate_url_opt/0","doc":"","ref":"NLdoc.Spec.Validation.html#t:validate_url_opt/0"},{"type":"function","title":"NLdoc.Spec.Validation.version/0","doc":"Returns the version of the NLdoc Validation spec that the `NLdoc.Spec` library implements.","ref":"NLdoc.Spec.Validation.html#version/0"},{"type":"module","title":"NLdoc.Test.Case.SpecExamples","doc":"This module provides a test method for spec example tests.\nImport this module after `use ExUnit.Case` in your test module.","ref":"NLdoc.Test.Case.SpecExamples.html"},{"type":"function","title":"NLdoc.Test.Case.SpecExamples.module_name/1","doc":"Returns the name of the given module.","ref":"NLdoc.Test.Case.SpecExamples.html#module_name/1"},{"type":"function","title":"Examples - NLdoc.Test.Case.SpecExamples.module_name/1","doc":"iex> module_name(NLdoc.Spec.Table)\n    \"NLdoc.Spec.Table\"\n\n    iex> module_name(Kernel)\n    \"Kernel\"","ref":"NLdoc.Test.Case.SpecExamples.html#module_name/1-examples"},{"type":"macro","title":"NLdoc.Test.Case.SpecExamples.test_spec_examples/3","doc":"This macro creates a suite of tests based on the given spec examples, use `NLdoc.Test.Spec.Examples`\nand `NLdoc.Test.Spec.ValidationExamples` to get the examples.\n\nEach spec example contains a list of test cases for a given spec module, where each test case contains\na scenario with a list of example objects. The macro will create a test for each example in the list,\nrunning the `assertion_func` on the result of calling `new/1` on the spec module with the example object as\nan argument.\n\nThe `assertion_func` should take two arguments: the result of calling `new/1` on the spec\nobject and a context map with the keys `module` and `scenario`.","ref":"NLdoc.Test.Case.SpecExamples.html#test_spec_examples/3"},{"type":"module","title":"NLdoc.Test.DocumentGenerator","doc":"# TODO: Write module documentation\n# TODO: determine what opts can be given.","ref":"NLdoc.Test.DocumentGenerator.html"},{"type":"function","title":"NLdoc.Test.DocumentGenerator.count_objects/1","doc":"Recursively count the number of objects in a document, or under a given spec object.\nThe count includes the object itself and all its children.\n\nThe given argument is ideally an `NLdoc.Spec.object()`, but can also be a map, as long as\nits structure is similar to the `NLdoc.Spec.object()` structure, particularly regarding the children.","ref":"NLdoc.Test.DocumentGenerator.html#count_objects/1"},{"type":"function","title":"NLdoc.Test.DocumentGenerator.generate/1","doc":"","ref":"NLdoc.Test.DocumentGenerator.html#generate/1"},{"type":"function","title":"NLdoc.Test.DocumentGenerator.generate_json/1","doc":"","ref":"NLdoc.Test.DocumentGenerator.html#generate_json/1"},{"type":"function","title":"NLdoc.Test.DocumentGenerator.generate_map/1","doc":"","ref":"NLdoc.Test.DocumentGenerator.html#generate_map/1"},{"type":"module","title":"NLdoc.Test.DocumentSpecExamples","doc":"This module is a test fixture that ensures the presence of examples.valid.json and examples.invalid.json\nthat are published by the NLdoc API (Document Specification) package on Gitlab.","ref":"NLdoc.Test.DocumentSpecExamples.html"},{"type":"function","title":"NLdoc.Test.DocumentSpecExamples.ensure_downloaded/0","doc":"","ref":"NLdoc.Test.DocumentSpecExamples.html#ensure_downloaded/0"},{"type":"function","title":"NLdoc.Test.DocumentSpecExamples.invalid/0","doc":"","ref":"NLdoc.Test.DocumentSpecExamples.html#invalid/0"},{"type":"function","title":"NLdoc.Test.DocumentSpecExamples.parse/1","doc":"","ref":"NLdoc.Test.DocumentSpecExamples.html#parse/1"},{"type":"function","title":"NLdoc.Test.DocumentSpecExamples.valid/0","doc":"","ref":"NLdoc.Test.DocumentSpecExamples.html#valid/0"},{"type":"module","title":"NLdoc.Test.SpecExamples","doc":"This module provides helper functions for loading and running tests on the NLdoc Spec examples.","ref":"NLdoc.Test.SpecExamples.html"},{"type":"function","title":"NLdoc.Test.SpecExamples.download/2","doc":"","ref":"NLdoc.Test.SpecExamples.html#download/2"},{"type":"function","title":"NLdoc.Test.SpecExamples.ensure_downloaded/3","doc":"","ref":"NLdoc.Test.SpecExamples.html#ensure_downloaded/3"},{"type":"function","title":"NLdoc.Test.SpecExamples.load_module/1","doc":"","ref":"NLdoc.Test.SpecExamples.html#load_module/1"},{"type":"module","title":"NLdoc.Test.UUIDGenerator","doc":"This module provides a UUID generator for testing purposes.\nAll UUIDs are valid v4 UUIDs, but are created sequentially so they are not random.\n\nExample:\n\n    iex> generator = NLdoc.Test.UUIDGenerator.new()\n    iex> NLdoc.Test.UUIDGenerator.generate(generator)\n    \"facade00-0000-4000-a000-000000000000\"\n    iex> NLdoc.Test.UUIDGenerator.generate(generator)\n    \"facade00-0000-4000-a000-000000000001\"\n    iex> NLdoc.Test.UUIDGenerator.generate(generator)\n    \"facade00-0000-4000-a000-000000000002\"\n    iex> NLdoc.Test.UUIDGenerator.generate(generator)\n    \"facade00-0000-4000-a000-000000000003\"\n\nCalling the `generate/1` function without a generator will return the same UUID each time.\n\n    iex> NLdoc.Test.UUIDGenerator.generate(nil)\n    \"facade00-0000-4000-a000-000000000000\"\n    iex> NLdoc.Test.UUIDGenerator.generate(nil)\n    \"facade00-0000-4000-a000-000000000000\"\n\nInspiration for this module's implementation taken from: https://elixirforum.com/t/implementing-a-counter-aka-how-to-keep-state-in-a-closure/17056/2","ref":"NLdoc.Test.UUIDGenerator.html"},{"type":"function","title":"NLdoc.Test.UUIDGenerator.close/1","doc":"","ref":"NLdoc.Test.UUIDGenerator.html#close/1"},{"type":"function","title":"NLdoc.Test.UUIDGenerator.generate/1","doc":"","ref":"NLdoc.Test.UUIDGenerator.html#generate/1"},{"type":"function","title":"NLdoc.Test.UUIDGenerator.new/0","doc":"","ref":"NLdoc.Test.UUIDGenerator.html#new/0"},{"type":"type","title":"NLdoc.Test.UUIDGenerator.t/0","doc":"","ref":"NLdoc.Test.UUIDGenerator.html#t:t/0"},{"type":"module","title":"NLdoc.Test.ValidationSpecExamples","doc":"This module is a test fixture that ensures the presence of examples.valid.json and examples.invalid.json\nthat are published by the NLdoc API (Document Specification) package on Gitlab.","ref":"NLdoc.Test.ValidationSpecExamples.html"},{"type":"function","title":"NLdoc.Test.ValidationSpecExamples.ensure_downloaded/0","doc":"","ref":"NLdoc.Test.ValidationSpecExamples.html#ensure_downloaded/0"},{"type":"function","title":"NLdoc.Test.ValidationSpecExamples.invalid/0","doc":"","ref":"NLdoc.Test.ValidationSpecExamples.html#invalid/0"},{"type":"function","title":"NLdoc.Test.ValidationSpecExamples.parse/1","doc":"","ref":"NLdoc.Test.ValidationSpecExamples.html#parse/1"},{"type":"function","title":"NLdoc.Test.ValidationSpecExamples.valid/0","doc":"","ref":"NLdoc.Test.ValidationSpecExamples.html#valid/0"},{"type":"extras","title":"NLdoc.Spec","doc":"# NLdoc.Spec\n\n**TODO: Add description**","ref":"readme.html"},{"type":"extras","title":"Installation - NLdoc.Spec","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `nldoc_spec` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:nldoc_spec, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"},{"type":"extras","title":"CHANGELOG","doc":"## [1.1.2](https://gitlab.com/toegang-voor-iedereen/backend/lib/nldoc_spec/compare/1.1.1...1.1.2) (2025-01-28)","ref":"changelog.html"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* **deps:** update dependency nldoc_util to v1.0.6 ([5e7ead7](https://gitlab.com/toegang-voor-iedereen/backend/lib/nldoc_spec/commit/5e7ead785bc409c35b2c8695bbd5917e9c89c4a7))\n\n## [1.1.1](https://gitlab.com/toegang-voor-iedereen/backend/lib/nldoc_spec/compare/1.1.0...1.1.1) (2025-01-27)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* **deps:** update dependency excoveralls to v0.18.5 ([d9f265d](https://gitlab.com/toegang-voor-iedereen/backend/lib/nldoc_spec/commit/d9f265dd8052b61c423d766d22d1be8a9a3bf588))\n\n# [1.1.0](https://gitlab.com/toegang-voor-iedereen/backend/lib/nldoc_spec/compare/1.0.2...1.1.0) (2025-01-23)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Features - CHANGELOG","doc":"* **NLD-586:** Include Validation Spec ([0d7d8b2](https://gitlab.com/toegang-voor-iedereen/backend/lib/nldoc_spec/commit/0d7d8b2866552bd9cd20c18540ca147e777c49ab))\n\n## [1.0.2](https://gitlab.com/toegang-voor-iedereen/backend/lib/nldoc_spec/compare/1.0.1...1.0.2) (2025-01-23)","ref":"changelog.html#features"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* format ([e55daea](https://gitlab.com/toegang-voor-iedereen/backend/lib/nldoc_spec/commit/e55daea68bed7959a4b093f89915712bc3afaf7c))\n\n## [1.0.1](https://gitlab.com/toegang-voor-iedereen/backend/lib/nldoc_spec/compare/1.0.0...1.0.1) (2025-01-23)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* **deps:** nldoc_test only necessary in test ([8efebaa](https://gitlab.com/toegang-voor-iedereen/backend/lib/nldoc_spec/commit/8efebaa9dbe66869a2d84847ba33c867422b3a7e))\n\n# 1.0.0 (2025-01-23)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* **deps:** update dependencies ([da55d6d](https://gitlab.com/toegang-voor-iedereen/backend/lib/nldoc_spec/commit/da55d6d732fcf0f3416c21086530ab2adf905fba))\n* formatting ([c9e61ce](https://gitlab.com/toegang-voor-iedereen/backend/lib/nldoc_spec/commit/c9e61ce030f09fcb3b525d3f5df296d7a70077d9))","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Features - CHANGELOG","doc":"* finalize lib ([e84c904](https://gitlab.com/toegang-voor-iedereen/backend/lib/nldoc_spec/commit/e84c904d3a7ad405a47259e2c20b18abb4b408b1))\n* finalize packageing ([4ff9619](https://gitlab.com/toegang-voor-iedereen/backend/lib/nldoc_spec/commit/4ff9619dfd31d5984e5527aae4ec527478d579ca))","ref":"changelog.html#features"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}